Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Action.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -26,6 +26,9 @@
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/ActionHistory.hpp"
+#include "Actions/OptionRegistry.hpp"
+#include "Actions/OptionTrait.hpp"
 #include "Exceptions/MissingValueException.hpp"
 #include "UIElements/Dialog.hpp"
+#include "Helpers/Assert.hpp"
 #include "Helpers/MemDebug.hpp"
 #include "UIElements/UIFactory.hpp"
@@ -44,9 +47,30 @@
 Action::state_ptr Action::failure = getEmptyState();
 
-Action::Action(std::string _name,bool _doRegister) :
-name(_name)
+Action::Action(const ActionTraits &_Traits, bool _doRegister) :
+    Traits(_Traits)
 {
+  // register with ActionRegistry
   if(_doRegister){
     ActionRegistry::getInstance().registerInstance(this);
+  }
+
+  // register with OptionRegistry
+  for (ActionTraits::options_const_iterator optioniter = Traits.getBeginIter();
+      optioniter != Traits.getEndIter();
+      ++optioniter) {
+    // options may have been re-used by other Actions, so check beforehand whether adding is needed
+    if (!OptionRegistry::getInstance().isOptionPresentByName((optioniter->first))) {
+      OptionRegistry::getInstance().registerInstance(optioniter->second);
+    } else { // if present, ASSERT that types coincide
+      OptionTrait const * const PresentOption = OptionRegistry::getInstance().getOptionByName(optioniter->first);
+      ASSERT(PresentOption->getType() == optioniter->second->getType(),
+          ("Action::Action() - option to add "+
+              std::string(optioniter->first)+
+              " of Action "+
+              std::string(getName())+
+              " is already present with different type!"
+          )
+      );
+    }
   }
 }
@@ -56,5 +80,5 @@
 
 const string Action::getName(){
-  return name;
+  return Traits.getName();
 }
 
Index: src/Actions/Action.hpp
===================================================================
--- src/Actions/Action.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Action.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,4 +11,10 @@
 #include <string>
 #include <boost/shared_ptr.hpp>
+
+/** Used in .def files in paramdefaults define to set that no default value exists.
+ * We define NODEFAULT here, as it is used in .def files and needs to be present
+ * before these are included.
+ */
+#define NODEFAULT std::string()
 
 // forward declaration
@@ -322,6 +328,12 @@
    * be registered with the ActionRegistry. If the Action is registered the name of the
    * Action needs to be unique for all Actions that are registered.
-   */
-  Action(std::string _name,bool _doRegister=true);
+   *
+   * \note NO reference for \a _Traits as we do have to copy it, otherwise _Traits would have
+   * to be present throughout the program's run.
+   *
+   * \param Traits information class to this action
+   * \param _doRegister whether to register with ActionRegistry
+   */
+  Action(const ActionTraits &_Traits, bool _doRegister=true);
   virtual ~Action();
 
@@ -366,7 +378,19 @@
    * Returns the name of the Action.
    */
-  virtual const std::string getName();
-
-  ActionTraits Traits;
+  const std::string getName();
+
+  /**
+   * Traits resemble all necessary information that "surrounds" an action, such as
+   * its name (for ActionRegistry and as ref from string to instance and vice versa),
+   * which menu, which position, what parameters, their types, if it is itself a
+   * parameter and so on ...
+   *
+   * Note that is important that we do not use a reference here. We want to copy the
+   * information in the Action's constructor and have it contained herein. Hence, we
+   * also have our own copy constructor for ActionTraits. Information should be
+   * encapsulated in the Action, no more references to the outside than absolutely
+   * necessary.
+   */
+  const ActionTraits Traits;
 
 protected:
@@ -445,6 +469,4 @@
    */
   virtual state_ptr performRedo(state_ptr)=0;
-
-  std::string name;
 };
 
Index: src/Actions/ActionHistory.cpp
===================================================================
--- src/Actions/ActionHistory.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionHistory.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -20,5 +20,5 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "ActionHistory.hpp"
+#include "Actions/ActionHistory.hpp"
 
 #include <iostream>
@@ -26,7 +26,4 @@
 #include "Patterns/Singleton_impl.hpp"
 #include "Helpers/Assert.hpp"
-#include "Helpers/MemDebug.hpp"
-
-using namespace std;
 
 ActionHistory::ActionHistory()
@@ -72,6 +69,4 @@
   ActionHistory *hist = new ActionHistory();
   setInstance(hist);
-  new UndoAction(hist);
-  new RedoAction(hist);
 }
 
@@ -80,91 +75,2 @@
 /****************** Contained actions *******************/
 
-const char ActionHistory::UndoAction::NAME[] = "undo";
-
-ActionHistory::UndoAction::UndoAction(ActionHistory *_hist) :
-  Action(NAME),
-  hist(_hist)
-{}
-
-ActionHistory::UndoAction::~UndoAction(){}
-
-bool ActionHistory::UndoAction::canUndo(){
-  return false;
-}
-
-bool ActionHistory::UndoAction::shouldUndo(){
-  return false;
-}
-
-bool ActionHistory::UndoAction::isActive(){
-  return hist->hasUndo();
-}
-
-void ActionHistory::UndoAction::getParametersfromValueStorage()
-{}
-
-Dialog* ActionHistory::UndoAction::fillDialog(Dialog *dialog){
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-  return dialog;
-}
-
-Action::state_ptr ActionHistory::UndoAction::performCall(){
-  std::cout << "Undo" << std::endl;
-  hist->undoLast();
-  return Action::success;
-}
-
-Action::state_ptr ActionHistory::UndoAction::performUndo(Action::state_ptr){
-  ASSERT(0,"Cannot undo an undo (should use redo for this");
-  return Action::success;
-}
-
-Action::state_ptr ActionHistory::UndoAction::performRedo(Action::state_ptr){
-  ASSERT(0,"Cannot redo an undo");
-  return Action::success;
-}
-
-const char ActionHistory::RedoAction::NAME[] = "redo";
-
-ActionHistory::RedoAction::RedoAction(ActionHistory *_hist) :
-    Action(NAME),
-    hist(_hist)
-{}
-
-ActionHistory::RedoAction::~RedoAction(){}
-
-bool ActionHistory::RedoAction::canUndo(){
-  return false;
-}
-
-bool ActionHistory::RedoAction::shouldUndo(){
-  return false;
-}
-
-bool ActionHistory::RedoAction::isActive(){
-  return hist->hasRedo();
-}
-
-void ActionHistory::RedoAction::getParametersfromValueStorage()
-{}
-
-Dialog* ActionHistory::RedoAction::fillDialog(Dialog *dialog){
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-  return dialog;
-}
-
-Action::state_ptr ActionHistory::RedoAction::performCall(){
-  std::cout << "Redo" << std::endl;
-  hist->redoLast();
-  return Action::success;
-}
-
-Action::state_ptr ActionHistory::RedoAction::performUndo(Action::state_ptr){
-  ASSERT(0,"Cannot undo a redo (should use undo for this");
-  return Action::success;
-}
-
-Action::state_ptr ActionHistory::RedoAction::performRedo(Action::state_ptr){
-  ASSERT(0,"Cannot redo a redo");
-  return Action::success;
-}
Index: src/Actions/ActionHistory.hpp
===================================================================
--- src/Actions/ActionHistory.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionHistory.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -14,4 +14,6 @@
 
 #include "Actions/Action.hpp"
+#include "Actions/RedoAction.hpp"
+#include "Actions/UndoAction.hpp"
 
 
@@ -27,49 +29,4 @@
     Action *action;
     Action::state_ptr state;
-  };
-
-  class UndoAction : public Action {
-  public:
-    UndoAction(ActionHistory*);
-    virtual ~UndoAction();
-
-    virtual bool canUndo();
-    virtual bool shouldUndo();
-
-    virtual bool isActive();
-  protected:
-    virtual Dialog * fillDialog(Dialog *dialog);
-  private:
-    virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-    virtual Action::state_ptr performUndo(Action::state_ptr);
-    virtual Action::state_ptr performRedo(Action::state_ptr);
-
-    ActionHistory *hist;
-
-    static const char NAME[];
-  };
-
-  class RedoAction : public Action {
-  public:
-    RedoAction(ActionHistory*);
-    virtual ~RedoAction();
-
-    virtual bool canUndo();
-    virtual bool shouldUndo();
-
-    virtual bool isActive();
-
-  protected:
-    virtual Dialog * fillDialog(Dialog *dialog);
-  private:
-    virtual void getParametersfromValueStorage();
-    virtual Action::state_ptr performCall();
-    virtual Action::state_ptr performUndo(Action::state_ptr);
-    virtual Action::state_ptr performRedo(Action::state_ptr);
-
-    ActionHistory *hist;
-
-    static const char NAME[];
   };
 
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionRegistry.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -47,5 +47,5 @@
  * \return true - Action instance present, false - not
  */
-bool ActionRegistry::isActionPresentByName(const std::string name)
+bool ActionRegistry::isActionPresentByName(const std::string name) const
 {
   return isPresentByName(name);
Index: src/Actions/ActionRegistry.hpp
===================================================================
--- src/Actions/ActionRegistry.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionRegistry.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -30,5 +30,5 @@
 public:
   Action* getActionByName(const std::string name);
-  bool isActionPresentByName(const std::string name);
+  bool isActionPresentByName(const std::string name) const;
 
 private:
Index: src/Actions/ActionTraits.cpp
===================================================================
--- src/Actions/ActionTraits.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionTraits.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -15,38 +15,76 @@
 #include "Actions/ActionTraits.hpp"
 
+#include "Helpers/Assert.hpp"
+
+#include <iostream>
+#include <sstream>
 #include <string>
+#include <typeinfo>
+
+/** Copy constructor for base class ActionTraits.
+ * \param &_Traits source ActionTraits class to copy
+ */
+ActionTraits::ActionTraits(const std::string &_token) :
+  OptionTrait(_token,
+      &typeid(void),
+      "this is an invisible action",
+      "",
+      ""
+  )
+{
+  std::cout << "ActionTraits::ActionTraits(string &) with " << getName() << ", type " << getTypeName() << " and description " << getDescription() << std::endl;
+}
+
+/** Copy constructor for base class ActionTraits.
+ * we have to make our own copy in order to avoid references and deep-copy everything.
+ * \param &_Traits source ActionTraits class to copy
+ */
+ActionTraits::ActionTraits(const ActionTraits &_Traits) :
+  OptionTrait(_Traits.getName(),
+      _Traits.getType(),
+      _Traits.getDescription(),
+      _Traits.hasDefaultValue() ? _Traits.getDefaultValue() : "",
+      _Traits.hasShortForm() ? _Traits.getShortForm() : ""
+  )
+{
+  MenuTitle = _Traits.MenuTitle;
+  MenuPosition = _Traits.MenuPosition;
+  for (options_const_iterator iter = _Traits.Options.begin(); iter != _Traits.Options.end(); ++iter) {
+    Options.insert(
+        std::pair< std::string, OptionTrait *> (
+            iter->first,
+            new OptionTrait(iter->second->getName(),iter->second->getType(),iter->second->getDescription(), iter->second->getDefaultValue(), iter->second->getShortForm())
+        )
+    );
+  }
+  std::cout << "ActionTraits::ActionTraits(ActionTraits &) with " << getName() << ", type " << getTypeName() << " and description " << getDescription() << std::endl;
+}
+
+/** Copy constructor for base class ActionTraits.
+ * we have to make our own copy in order to avoid references and deep-copy everything.
+ * \param &_Traits source OptionTrait class to copy
+ */
+ActionTraits::ActionTraits(const OptionTrait &_Traits) :
+  OptionTrait(_Traits)
+{
+  std::cout << "ActionTraits::ActionTraits(OptionTrait &) with " << getName() << ", type " << getTypeName() << " and description " << getDescription() << std::endl;
+}
 
 /** Constructor for base class ActionTraits.
- *
- */
-ActionTraits::ActionTraits()
-{}
-
-/** Constructor for base class ActionTraits.
- *
+ * Deletes all present Options.
  */
 ActionTraits::~ActionTraits()
-{}
-
-/** Returns Current Value for this ActionTrait.
- * \return ActionTraits::CurrentValue as std::string
- */
-const std::string ActionTraits::getCurrentValue() const
 {
- return CurrentValue;
+  for (options_iterator iter = Options.begin(); !Options.empty(); iter = Options.begin()) {
+    delete (iter->second);
+    Options.erase(iter);
+  }
 }
 
-/** Returns Description for this ActionTrait.
- * \return ActionTraits::Description as std::string
- */
-const std::string ActionTraits::getDescription() const
-{
-  return Description;
-}
 
 /** Returns menu title for this ActionTrait.
  * \return ActionTraits::MenuTitle as std::string
  */
-const std::string ActionTraits::getMenuName() const
+const std::string& ActionTraits::getMenuName() const
 {
   return MenuTitle;
@@ -62,29 +100,29 @@
 
 /** Returns Description for the given option of this ActionTrait.
- * \param token of option
- * \return ActionTraits::OptionDescription as std::string
+ * \param &token token of option
+ * \return reference to OptionTrait
  */
-const std::string ActionTraits::getOptionDescription(const std::string descr) const
+OptionTrait const & ActionTraits::getOption(const std::string &token) const
 {
-  if (OptionDescription.find(descr) != OptionDescription.end())
-    return OptionDescription.find(descr)->second;
-  else
-    return std::string();
+  ASSERT(Options.find(token) != Options.end(),
+      "ActionTraits::getOption() - Option not found!");
+  return *(Options.find(token)->second);
 }
 
-/** Returns ShortForm for this ActionTrait.
- * \return ActionTraits::ShortForm as std::string
+/** States whether given option (token) is present or not.
+ * \param &token name of option
+ * \return true - option present, false - not
  */
-const std::string ActionTraits::getShortForm() const
+bool ActionTraits::hasOption(const std::string &token) const
 {
-  return ShortForm;
+  return (Options.find(token) != Options.end());
 }
 
-/** Returns Type for this ActionTrait.
- * \return ActionTraits::InternalType as std::type_info reference
+/** States whether this Action has options at all.
+ * \return true - options present, false - no options
  */
-const std::type_info * ActionTraits::getType() const
+bool ActionTraits::hasOptions() const
 {
-  return InternalType;
+  return (Options.begin() != Options.end());
 }
 
@@ -94,5 +132,5 @@
 ActionTraits::options_iterator ActionTraits::getBeginIter()
 {
-  return OptionDescription.begin();
+  return Options.begin();
 }
 
@@ -102,5 +140,5 @@
 ActionTraits::options_iterator ActionTraits::getEndIter()
 {
-  return OptionDescription.end();
+  return Options.end();
 }
 
@@ -110,5 +148,5 @@
 ActionTraits::options_const_iterator ActionTraits::getBeginIter() const
 {
-  return OptionDescription.begin();
+  return Options.begin();
 }
 
@@ -118,5 +156,5 @@
 ActionTraits::options_const_iterator ActionTraits::getEndIter() const
 {
-  return OptionDescription.end();
+  return Options.end();
 }
 
Index: src/Actions/ActionTraits.hpp
===================================================================
--- src/Actions/ActionTraits.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ActionTraits.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -15,5 +15,6 @@
 
 #include <map>
-#include <string>
+
+#include "Actions/OptionTrait.hpp"
 
 /** Interface for all ActionTraits.
@@ -27,19 +28,23 @@
  *
  */
-class ActionTraits {
+class ActionTraits : public OptionTrait {
 public:
-  explicit ActionTraits();
+  ActionTraits(const ActionTraits &_Traits);
+  ActionTraits(const OptionTrait &_Traits);
+  explicit ActionTraits(const std::string &_token);
   virtual ~ActionTraits();
 
-  typedef std::map<std::string, std::string>::iterator    options_iterator;
-  typedef std::map<std::string, std::string>::const_iterator    options_const_iterator;
+  typedef std::map< std::string, OptionTrait* > options_map;
+  typedef options_map::iterator                 options_iterator;
+  typedef options_map::const_iterator           options_const_iterator;
 
-  const std::string getCurrentValue() const;
-  const std::string getDescription() const;
-  const std::string getMenuName() const;
+  const std::string& getMenuName() const;
   const int getMenuPosition() const;
-  const std::string getOptionDescription(const std::string descr) const;
-  const std::string getShortForm() const;
-  const std::type_info * getType() const;
+
+  // getter for its options
+  OptionTrait const &getOption(const std::string &token) const;
+
+  bool hasOption(const std::string &token) const;
+  bool hasOptions() const;
 
   options_iterator getBeginIter();
@@ -51,11 +56,7 @@
 
   // internal information this trait contains
-  std::string CurrentValue;
-  std::string Description;
   std::string MenuTitle;
   int MenuPosition;
-  std::map<std::string, std::string> OptionDescription;
-  std::string ShortForm;
-  const std::type_info *InternalType;
+  options_map Options;
 };
 
Index: src/Actions/Action_impl_header.hpp
===================================================================
--- src/Actions/Action_impl_header.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Action_impl_header.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -20,11 +20,21 @@
 #include <boost/preprocessor/seq/transform.hpp>
 
+#include <iostream>
+#include <typeinfo>
+
+#include "Actions/ActionTraits.hpp"
+#include "Actions/OptionTrait.hpp"
 #include "Actions/ValueStorage.hpp"
 
-// some derived names
+// some derived names: if CATEGORY is not given, we don't prefix with it
+#ifdef CATEGORY
 #define ACTION BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Action))
 #define COMMAND BOOST_PP_CAT(CATEGORY, ACTIONNAME)
 #define PARAMS BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Parameters))
-
+#else
+#define ACTION BOOST_PP_CAT(ACTIONNAME, Action)
+#define COMMAND ACTIONNAME
+#define PARAMS BOOST_PP_CAT(ACTIONNAME, Parameters)
+#endif
 // check if no lists given
 #ifndef paramtypes
@@ -35,8 +45,4 @@
 
 // check user has given name and category
-#ifndef CATEGORY
-ERROR: No "CATEGORY" defined in: __FILE__
-#endif
-
 #ifndef ACTIONNAME
 ERROR: No "ACTIONNAME" defined in: __FILE__
@@ -66,7 +72,20 @@
 )
 #endif
-#ifndef TYPEINFO
-BOOST_PP_ASSERT_MSG(0, \
-    "ERROR: Type is mandatory for Actions, here for ACTION " \
+
+// check if paramdefaults is given, otherwise fill list with NODEFAULT
+// this does not work: paramdefaults has to be completely defined before
+// being used within option_print (used as an array there and not as
+// some function call still to be expanded)
+//#define paramdefaults (NODEFAULT)
+//#define tempvalue(z,n,value)
+//  BOOST_PP_CAT(value,(NODEFAULT))
+//BOOST_PP_REPEAT(tempvalue, MAXPARAMTYPES, paramdefaults)
+//#undef tempvalue
+//#else
+
+// if present, check if correct number of arguments
+#ifdef paramdefaults
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXPARAMTYPES, BOOST_PP_SEQ_SIZE(paramdefaults)),\
+  ERROR: There are not the same number of "paramtokens" and "paramdefaults" in: __FILE__ \
 )
 #endif
@@ -84,12 +103,32 @@
   BOOST_PP_SEQ_ELEM(n, VARLIST)
 
-// prints OptionDescription.insert
-#define optiondescription_print(z,n,unused, unused2) \
-  OptionDescription. insert (\
-      pair<std::string, std::string> (\
-  BOOST_PP_SEQ_ELEM(n, paramtokens), \
-  BOOST_PP_SEQ_ELEM(n, paramdescriptions) )\
-  );
-
+// prints Options.insert
+#ifdef paramdefaults
+#define option_print(z,n,unused, unused2) \
+  tester = Options. insert (\
+      std::pair< std::string, OptionTrait *> ( \
+      BOOST_PP_SEQ_ELEM(n, paramtokens), \
+      new OptionTrait(\
+          BOOST_PP_SEQ_ELEM(n, paramtokens), \
+          &typeid( BOOST_PP_SEQ_ELEM(n, paramtypes) ), \
+          BOOST_PP_SEQ_ELEM(n, paramdescriptions), \
+          BOOST_PP_SEQ_ELEM(n, paramdefaults) )\
+      )\
+  ); \
+  ASSERT(tester.second, "ActionTrait<ACTION>::ActionTrait<ACTION>() option token present twice!");
+#else
+#define option_print(z,n,unused, unused2) \
+  tester = Options. insert (\
+      std::pair< std::string, OptionTrait *> ( \
+      BOOST_PP_SEQ_ELEM(n, paramtokens), \
+      new OptionTrait(\
+          BOOST_PP_SEQ_ELEM(n, paramtokens), \
+          &typeid( BOOST_PP_SEQ_ELEM(n, paramtypes) ), \
+          BOOST_PP_SEQ_ELEM(n, paramdescriptions), \
+          NODEFAULT )\
+      )\
+  ); \
+  ASSERT(tester.second, "ActionTrait<ACTION>::ActionTrait<ACTION>() option token present twice!");
+#endif
 
 #if defined paramtypes && defined paramreferences
@@ -108,29 +147,32 @@
 class ActionTrait<ACTION> : public ActionTraits {
 public:
-  ActionTrait()
+  ActionTrait() :
+#ifndef SHORTFORM
+    ActionTraits(OptionTrait(TOKEN, &typeid(void), DESCRIPTION, std::string()))
+#else
+    ActionTraits(OptionTrait(TOKEN, &typeid(void), DESCRIPTION, std::string(), SHORTFORM))
+#endif /* SHORTFORM */
   {
-#ifdef DEFAULTVALUE
-    CurrentValue = DEFAULTVALUE;
-#endif
-#ifdef DESCRIPTION
-    Description = DESCRIPTION;
-#endif
-#ifdef paramdescriptions
-#define BOOST_PP_LOCAL_MACRO(n) optiondescription_print(~, n, ~, )
+  // initialize remainder of action info
+#ifdef MENUNAME
+    MenuTitle = MENUNAME;
+#endif
+#ifdef MENUPOSITION
+    MenuPosition = MENUPOSITION;
+#endif
+
+  // initialize action's options
+  std::pair< ActionTraits::options_iterator, bool > tester;
+#ifdef paramtokens
+#define BOOST_PP_LOCAL_MACRO(n) option_print(~, n, ~, )
 #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
 #include BOOST_PP_LOCAL_ITERATE()
 #endif
-#ifdef MENUNAME
-    MenuTitle = MENUNAME;
-#endif
-#ifdef MENUPOSITION
-    MenuPosition = MENUPOSITION;
-#endif
+  // associate action's short form also with option
 #ifdef SHORTFORM
-    ShortForm = SHORTFORM;
-#endif
-#ifdef TYPEINFO
-    InternalType = TYPEINFO;
-#endif
+  if (Options.find(TOKEN) != Options.end())
+    Options[TOKEN]->setShortForm(std::string(SHORTFORM));
+#endif /* SHORTFORM */
+  std::cout << "ActionTrait<ACTION>::ActionTrait() with " << getName() << ", type " << getTypeName() << " and description " << getDescription() << std::endl;
   }
 
@@ -139,7 +181,6 @@
 
 class ACTION : public Action {
-  friend
   #if defined paramtypes && defined paramreferences
-  void COMMAND(
+  friend void COMMAND(
   #define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, paramtypes, paramreferences)
   #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
@@ -157,6 +198,4 @@
   bool shouldUndo();
 
-  virtual const std::string getName();
-
   struct PARAMS : ActionParameters {
   #if defined paramtypes && defined paramreferences
@@ -167,6 +206,4 @@
   } params;
 
-  ActionTrait<ACTION> Traits;
-
 protected:
   virtual Dialog * fillDialog(Dialog*);
@@ -176,6 +213,4 @@
   virtual Action::state_ptr performUndo(Action::state_ptr);
   virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
 };
 
@@ -183,4 +218,6 @@
 #undef paramtokens
 #undef paramreferences
+#undef paramdescriptions
+#undef paramdefaults
 #undef MAXPARAMTYPES
 #undef statetypes
@@ -195,3 +232,8 @@
 #undef ACTIONNAME
 #undef CATEGORY
+#undef MENUNAME
+#undef MENUPOSITION
 #undef TOKEN
+
+#undef DESCRIPTION
+#undef SHORTFORM
Index: src/Actions/Action_impl_pre.hpp
===================================================================
--- src/Actions/Action_impl_pre.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Action_impl_pre.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -42,9 +42,16 @@
 #include <boost/preprocessor/seq/transform.hpp>
 
-// some derived names
+// some derived names: if CATEGORY is not given, we don't prefix with it
+#ifdef CATEGORY
 #define ACTION BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Action))
 #define COMMAND BOOST_PP_CAT(CATEGORY, ACTIONNAME)
 #define STATE BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, State))
 #define PARAMS BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Parameters))
+#else
+#define ACTION BOOST_PP_CAT(ACTIONNAME, Action)
+#define COMMAND ACTIONNAME
+#define STATE BOOST_PP_CAT(ACTIONNAME, State)
+#define PARAMS BOOST_PP_CAT(ACTIONNAME, Parameters)
+#endif
 #define INSTANCE BOOST_PP_CAT(this_, BOOST_PP_CAT(ACTIONNAME, _instance))
 
@@ -62,8 +69,4 @@
 
 // check user has given name and category
-#ifndef CATEGORY
-ERROR: No "CATEGORY" defined in: __FILE__
-#endif
-
 #ifndef ACTIONNAME
 ERROR: No "ACTIONNAME" defined in: __FILE__
@@ -111,7 +114,6 @@
   >(\
   BOOST_PP_SEQ_ELEM(n, paramtokens)\
-  , ValueStorage::getInstance().getDescription(\
-  BOOST_PP_SEQ_ELEM(n, paramtokens)\
-  ));
+  , Traits.getDescription()\
+  );
 
 // prints set/queryCurrentValue (command) for paramreferences and paramtokens
@@ -126,8 +128,14 @@
 #include "Actions/ActionRegistry.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-
+
+#ifdef paramtokens
+#define statenecessary 1
+#endif
+#ifndef statetokens
+#define statenecessary 1
+#endif
 
 // =========== memento to remember the state when undoing ===========
+#ifdef statenecessary
 class STATE : public ActionState {
 public:
@@ -155,7 +163,5 @@
   ACTION::PARAMS params;
 };
-
-// =========== name of action ===========
-const char ACTION::NAME[] = TOKEN;
+#endif /* statenecessary */
 
 // (const) prototype to be placed into the ActionRegistry (must be deleted by registry itself)
@@ -164,10 +170,12 @@
 // =========== constructor ===========
 ACTION::ACTION () :
-  Action(NAME)
+  Action(ActionTrait<ACTION>())
 {}
 
 // =========== destructor ===========
 ACTION::~ACTION ()
-{}
+{
+  //std::cout << "Action ACTION is being destroyed." << std::endl;
+}
 
 // =========== fill a dialog ===========
@@ -175,5 +183,5 @@
         ASSERT(dialog,"No Dialog given when filling actionname's dialog");
 #if BOOST_PP_EQUAL(MAXPARAMTYPES,0)
-        dialog->queryEmpty(NAME, Traits.getDescription());
+        dialog->queryEmpty(TOKEN, Traits.getDescription());
 #else
 #define BOOST_PP_LOCAL_MACRO(n) dialog_print(~, n, ~)
@@ -196,5 +204,5 @@
 {
   ACTION::PARAMS params;
-  Action *ToCall = ActionRegistry::getInstance().getActionByName( ACTION::NAME ); //->clone(params);
+  Action *ToCall = ActionRegistry::getInstance().getActionByName( TOKEN ); //->clone(params);
 #if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
 #define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, setCurrentValue, )
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -82,7 +82,3 @@
   return true;
 }
-
-const string AnalysisMolecularVolumeAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/MolecularVolumeAction.def
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -10,9 +10,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
@@ -24,6 +25,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "calculate the volume of a given molecule"
 #undef SHORTFORM
-#define TYPEINFO &typeid(molecule)
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -54,6 +54,6 @@
 
   // execute action
-  output.open(params.outputname.c_str());
-  binoutput.open(params.binoutputname.c_str());
+  output.open(params.outputname.string().c_str());
+  binoutput.open(params.binoutputname.string().c_str());
   PairCorrelationMap *correlationmap = NULL;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
@@ -87,7 +87,3 @@
   return true;
 }
-
-const string AnalysisPairCorrelationAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/PairCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PairCorrelationAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -13,9 +13,10 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::vector<const element *>)(double)(double)(double)(std::string)(std::string)(bool)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (std::vector<const element *>)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (elements)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("elements")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("set of elements")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
+#define paramdefaults (NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
@@ -27,6 +28,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "pair correlation analysis between two elements"
 #define SHORTFORM "C"
-#define TYPEINFO &typeid(void)
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -56,6 +56,6 @@
 
   // execute action
-  output.open(params.outputname.c_str());
-  binoutput.open(params.binoutputname.c_str());
+  output.open(params.outputname.string().c_str());
+  binoutput.open(params.binoutputname.string().c_str());
   cout << "Point to correlate to is  " << params.Point << endl;
   CorrelationToPointMap *correlationmap = NULL;
@@ -92,7 +92,3 @@
   return true;
 }
-
-const string AnalysisPointCorrelationAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
